
string_target_list= [u'Bip_Collar_L', u'Bip_Collar_R', u'L_pistonsD', u'L_pistonsC', u'L_pistonsB', u'L_pistonsA', u'R_pistonsD', u'R_pistonsC', u'R_pistonsB', u'R_pistonsA'] 
string_slave_list= [u'L_pistonsC', u'R_pistonsC', u'L_pistonsC', u'L_pistonsD', u'L_pistonsA', u'L_pistonsB', u'R_pistonsC', u'R_pistonsD', u'R_pistonsA', u'R_pistonsB'] 
string_constraint_list= [u'Parent Constraint', u'Parent Constraint', u'Aim Constraint', u'Aim Constraint', u'Aim Constraint', u'Aim Constraint', u'Aim Constraint', u'Aim Constraint', u'Aim Constraint', u'Aim Constraint']
#created with Constraint Helper V1.1
import vsUtils
from PySide import QtCore, QtGui
def error(e):
    
    #error box

    msgBox = QtGui.QMessageBox(QtGui.QMessageBox.Critical,"ERROR",str(e), QtGui.QMessageBox.NoButton)


    msgBox.addButton("&Continue", QtGui.QMessageBox.RejectRole)
    if msgBox.exec_() == QtGui.QMessageBox.AcceptRole:pass

def CreateConstraint( target, slave,Constraint,bCreateControls=True, group=None ,offset=True,puppet=False,puppet_dagdir={}) :
    ''' Method for creating a single target orient constraint '''

    if ( target == None ):
        return
        
    
    
    targetDag = sfmUtils.FindFirstDag( [  target  ], True )
    
    
   
    if puppet:
        slaveDag =puppet_dagdir[slave]
        ConstraintGroup= puppet_animset.GetRootControlGroup().CreateControlGroup( "Constraints" )
        ConstraintGroup.SetGroupColor(vs.Color( 0, 128, 255, 255 ),False)        
        puppet_animset.GetRootControlGroup().AddChild(ConstraintGroup)
        
        
    else:
        slaveDag = sfmUtils.FindFirstDag( [  slave  ], True )
        ConstraintGroup=rootGroup.CreateControlGroup( "Constraints" )
        ConstraintGroup.SetGroupColor(vs.Color( 0, 128, 255, 255 ),False)
        rootGroup.AddChild(ConstraintGroup)
   
        
    sfmUtils.AddDagControlsToGroup(ConstraintGroup,slaveDag)
    ConstraintGroup.SetSelectable( False )
    ConstraintGroup.SetVisible( False )
    sfm.PushSelection()
    sfmUtils.SelectDagList( [ targetDag, slaveDag ] )
    
    if Constraint=='Aim Constraint':
        orientConstraintTarget = sfm.AimConstraint( controls=bCreateControls, mo=offset )
    elif Constraint=='Orient Constraint':
        orientConstraintTarget = sfm.OrientConstraint(controls=bCreateControls, mo=offset )
    elif Constraint=='Point Constraint':
        orientConstraintTarget = sfm.PointConstraint( controls=bCreateControls, mo=offset )       
    elif Constraint=='Parent Constraint':
        orientConstraintTarget = sfm.ParentConstraint( controls=bCreateControls, mo=offset )

   
        
    if ( group != None ):

        if ( orientConstraintTarget != None ):
            orientWeightControl = orientConstraintTarget.FindWeightControl()
            if ( orientWeightControl != None ):
                group.AddControl( orientWeightControl )

    sfm.PopSelection()
    return


def get_dag_list(child):
    for num in range(child.GetChildCount()):
            tmpDag = child.GetChild(num)
            if tmpDag == None:
                    break
            b=str(tmpDag.GetName()).find('(')
           
            bonename=str(tmpDag.GetName())[b+1:-1]

            
            puppet_dir[bonename]=tmpDag
            if tmpDag.GetChildCount()>0:
                    get_dag_list(tmpDag)


    
animSet = sfm.GetCurrentAnimationSet()
rootGroup = animSet.GetRootControlGroup()

enable_puppet=False
puppet_animset_name="cubemap_sheen_dome21"

allAnimSets = []
puppet_dir={}
puppet_animset=None

if enable_puppet:
    shot = sfm.GetCurrentShot()
	    
	    # Empty array
    
    #code from  revzin.net
    for shotAttribute in shot.iterAttrs():
       if shotAttribute.GetName() == "animationSets": 
	  for animSet in shotAttribute:
	     if puppet_animset_name == animSet.GetName():
	         puppet_animset=animSet
	         break
    if  puppet_animset:
	get_dag_list(puppet_animset.gameModel)
    else:
	error("\nCould not find this animset: "+puppet_animset_name)
        string_target_list=[]          
for i in range(len(string_target_list)):
    CreateConstraint(string_target_list[i],string_slave_list[i],string_constraint_list[i],puppet=enable_puppet,puppet_dagdir=puppet_dir)

